#include "code.h"
#include <Windows.h>

//---------------------------------------------------------------------
// GR[fBO
// 쐬 20170810
//  srcF
//  lengthF񒷂
// ߂lFGR[fBO
//---------------------------------------------------------------------
EncodingType GetEncoding(const char *src, unsigned int length)
{
	int utf8 = 0;		// UTF-8
	int sjis = 0;		// ShiftJIS
	unsigned char b1;	// PoCg
	unsigned char b2;	// QoCg
	unsigned char b3;	// RoCg
	unsigned char b4;	// SoCg
	bool isASCII;		// AXL[ł

	// UTF-16 BOM
	if (2 <= length)
	{
		// UTF-16 LE
		if ((src[0] == 0xffffffff) && (src[1] == 0xfffffffe))
		{
			return EncodingType::UTF16;
		}
	
		// UTF-16 BE
		if ((src[0] == 0xfffffffe) && (src[1] == 0xffffffff))
		{
			return EncodingType::UTF16BE;
		}
	}

	// UTF-8 BOM
	if (3 <= length)
	{
		if ((src[0] == 0xffffffef) && (src[1] == 0xffffffbb) && (src[2] == 0xffffffbf))
		{
			return EncodingType::UTF8BOM;
		}
	}

	// 0x0݁BINARYFC 20210109 KrKFv1.2
	for (unsigned int i = 0; i < length; i++)
	{
		if (src[i] == 0x00)
		{
			return EncodingType::BINARY;
		}
	}

	// ׂăAXL[R[hH
	isASCII = true;
	for (unsigned int i = 0; i< length; i++)
	{
		// AXL[R[hH
		b1 = src[i];
		if (0x7E < b1)
		{
			isASCII = false;
			break;
		}
	}
	if (isASCII == true)
	{
		return EncodingType::SHIFTJIS;
	}

	// UTF-8擾
	for (unsigned int i = 0; i < length; ++i)
	{
		b1 = src[i];
		// `
		if ((b1 == 0xA0) || (b1 == 0xFF))
		{
		}
		// ASCIIFǉ 20200101 KrKFv1.1
		else if ((0x00 <= b1) && (b1 <= 0x7F))
		{
			utf8 += 1;
		}
		// ASCIIȊO
		else if (i < (length - 1))
		{
			// 2byte
			b2 = src[i + 1];
			if (((0xC0 <= b1) && (b1 <= 0xDF)) &&
				((0x80 <= b2) && (b2 <= 0xBF)))
			{
				i += 1;
				utf8 += 2;
			}
			else if (i < (length - 2))
			{
				// 3byte
				b3 = src[i + 2];
				if (((0xE0 <= b1) && (b1 <= 0xEF)) &&
					((0x80 <= b2) && (b2 <= 0xBF)) &&
					((0x80 <= b3) && (b3 <= 0xBF)))
				{
					i += 2;
					utf8 += 3;
				}
				else if (i < (length - 3))
				{
					// 4byte
					b4 = src[i + 3];
					if (((0xF0 <= b1) && (b1 <= 0xF7)) &&
						((0x80 <= b2) && (b2 <= 0xBF)) &&
						((0x80 <= b3) && (b3 <= 0xBF)) &&
						((0x80 <= b4) && (b4 <= 0xBF)))
					{
						i += 3;
						utf8 += 4;
					}
				}
				// UTF-8ł͂Ȃ
				else
				{
					utf8 = -1;
					break;
				}
			}
		}
	}

	// ShiftJIS擾
	for (unsigned int i = 0; i < length; i++)
	{
		b1 = src[i];
		// `
		if ((b1 == 0xA0) || (b1 == 0xFF))
		{
		}
		// ASCII
		else if ((0x00 <= b1) && (b1 <= 0x7F))
		{
			// ǉ 20200101 KrKFv1.1
			sjis += 1;
		}
		// pJ^Ji
		else if ((0xA1 <= b1) && (b1 <= 0xDF))
		{
			sjis += 1;
		}
		// ASCIIApJ^JiȊO
		else if (i < (length - 1))
		{
			// 1byteF0x810x9FA0xE00xFC
			// 2byteF0x400x7EA0x800xFC
			b2 = src[i + 1];
			if ((((0x81 <= b1) && (b1 <= 0x9F)) || ((0xE0 <= b1) && (b1 <= 0xFC))) &&
				(((0x40 <= b2) && (b2 <= 0x7E)) || ((0x80 <= b2) && (b2 <= 0xFC))))
			{
				i += 1;
				sjis += 2;
			}
			// VtgihrłȂ
			else
			{
				sjis = -1;
				break;
			}
		}
	}

	// ǂ̕
	if (sjis == utf8)
	{
//		return EncodingType::SHIFTJIS;
		return EncodingType::UTF8;
	}
	else if (sjis < utf8)
	{
		return EncodingType::UTF8;
	}
	else
	{
		return EncodingType::SHIFTJIS;
	}
}
